<?php
/******************************
 * $Id: index.php 20 2006-12-30 09:07:14Z zanix $
 ******************************/

if ( !defined('ROSTER_INSTALLED') )
{
    exit('Detected invalid access to this file!');
}
require_once($_SERVER['DOCUMENT_ROOT'].$roster_conf['roster_dir'].'/addons/guildvault/includes/lib_functions.php');

$table_guildvault_config_exists = checkDb(ROSTER_GUILDVAULT_CONFIG_TABLE);
$table_guildvault_content_exists = checkDb(ROSTER_GUILDVAULT_CONTENT_TABLE);
$table_guildvault_log_exists = checkDb(ROSTER_GUILDVAULT_LOG_TABLE);
$table_guildvault_money_exists = checkDb(ROSTER_GUILDVAULT_MONEY_TABLE);

if ($table_guildvault_config_exists != true) {
  	$sql = 'CREATE TABLE `'.ROSTER_GUILDVAULT_CONFIG_TABLE.'` (`tab` varchar(100) NOT NULL, `name` varchar(255) NOT NULL, `icon` varchar(255) NOT NULL, KEY `tab` (`tab`)) ENGINE=MyISAM;';
	if (!$wowdb->query($sql)) {
	 	$failed_queries[] = $sql; 
	}
}
if ($table_guildvault_content_exists != true) {
  	$sql = 'CREATE TABLE `'.ROSTER_GUILDVAULT_CONTENT_TABLE.'` (`tab` varchar(100) NOT NULL, `item_num` int(3) NOT NULL, `item_name` varchar(255) NOT NULL, `item_color` varchar(255) NOT NULL, `item_tooltip` text NOT NULL, `item_icon` varchar(255) NOT NULL, `item_id` varchar(255) NOT NULL, `item_quantity` int(3) NOT NULL, KEY `tab` (`tab`), KEY `item_num` (`item_num`), KEY `item_name` (`item_name`)) ENGINE=MyISAM;';
	if (!$wowdb->query($sql)) {
	 	$failed_queries[] = $sql; 
	}
}
if ($table_guildvault_log_exists != true) {
  	$sql = 'CREATE TABLE `'.ROSTER_GUILDVAULT_LOG_TABLE.'` (`tab` varchar(100) NOT NULL, `log_num` int(3) NOT NULL, `log_type` varchar(255) NOT NULL, `log_name` varchar(255) NOT NULL, `log_item` varchar(255) NOT NULL, `log_count` int(3) NOT NULL, `log_time` varchar(255) NOT NULL, KEY `tab` (`tab`)) ENGINE=MyISAM;';
	if (!$wowdb->query($sql)) {
	 	$failed_queries[] = $sql; 
	}
}
if ($table_guildvault_money_exists != true) {
  	$sql = 'CREATE TABLE `'.ROSTER_GUILDVAULT_MONEY_TABLE.'` (`copper` tinyint(2) NOT NULL, `silver` tinyint(2) NOT NULL, `gold` int(9) NOT NULL, KEY `copper` (`copper`,`silver`,`gold`)) ENGINE=MyISAM;';
	if (!$wowdb->query($sql)) {
	 	$failed_queries[] = $sql; 
	}
}
$updateTime = date($phptimeformat[$roster_conf['roster_lang']],strtotime($guild_info['update_time']));

//begin generation the addon's output

# Load configuration into array
$config = load_config();

# Load content data into array
$contents = get_content_data($config);

# First check if output should generated
if ($addon_conf['guildvault']['generate_output'])
{
  	# Check if is there a array with the content, else give no
	if (!is_array($contents)) {
  		echo $wordings[$roster_conf['roster_lang']]['loc_guildvault']['no_data']."\n\r";
		return;
	}
	else {
		if ((isset($_REQUEST['action'])) && ($_REQUEST['action'] == 'config')) {
			require_once ($_SERVER['DOCUMENT_ROOT'].$roster_conf['roster_dir'].'/addons/guildvault/includes/configuration.php');
			return;
		}
		if ($addon_conf['guildvault']['show_like_ingame'] == 1) {
		  	if ($addon_conf['guildvault']['show_tabs'] == 0) {
	  			require_once ($_SERVER['DOCUMENT_ROOT'].$roster_conf['roster_dir'].'/addons/guildvault/includes/ingame.php');
				return;
	  		}
	  		else {
	  	  		if ($addon_conf['guildvault']['use_javascript'] == 0) {
		    		require_once ($_SERVER['DOCUMENT_ROOT'].$roster_conf['roster_dir'].'/addons/guildvault/includes/ingame_single_nojava.php');
					return;
				}
				else {
			    	require_once ($_SERVER['DOCUMENT_ROOT'].$roster_conf['roster_dir'].'/addons/guildvault/includes/ingame_single.php');			  
					return;
				}
			}
		}
		else {
			require_once ($_SERVER['DOCUMENT_ROOT'].$roster_conf['roster_dir'].'/addons/guildvault/includes/sorted.php');  
			return;
		}
	}
}

if ($addon_conf['guildvault']['debug'] == 1) {
	if (is_array($failed_queries)) {
  		foreach ($failed_queries as $sql) {
	    	$wowdb->query($sql);
		    echo $sql."<br />".$wowdb->error()."<br />";
		}
		echo "<hr />";
	}
}

if ($roster_conf['sqldebug'])
{
	print "<!-- $query -->\n";
}
