<?php
/******************************
 * $Id: trigger.php 20 2006-12-30 09:07:14Z zanix $
 ******************************/

if ( !defined('ROSTER_INSTALLED') )
{
    exit('Detected invalid access to this file!');
}

require_once ($_SERVER['DOCUMENT_ROOT'].$roster_conf['roster_dir'].'/addons/guildvault/localization.php');

global $uploadData, $db_prefix, $wordings;

if( $mode == 'guild_post' )
{
	if( $addon_conf['guildvault']['updateguildvault'] ) {

		# Check if DB-Tables exists
		$table_guildvault_config_exists = checkDb($db_prefix.'guildvault_config');
		$table_guildvault_content_exists = checkDb($db_prefix.'guildvault_contents');
		$table_guildvault_log_exists = checkDb($db_prefix.'guildvault_logs');
		$table_guildvault_money_exists = checkDb($db_prefix.'guildvault_money');

		# If all or one Table does not exist it will be created
		if ($table_guildvault_config_exists != true) {
  			$sql = 'CREATE TABLE IF NOT EXISTS `'.$db_prefix.'guildvault_config` (`tab` varchar(100) NOT NULL, `name` varchar(255) NOT NULL, `icon` varchar(255) NOT NULL, KEY `tab` (`tab`,`name`)) ENGINE=MyISAM;';
		} else {
		  	$sql = "TRUNCATE TABLE `".$db_prefix."guildvault_config`";
		}
		if (!$wowdb->query($sql)) {
		  	$failed_querys[] = $sql;
		}
		if ($table_guildvault_content_exists != true) {
	  		$sql = 'CREATE TABLE IF NOT EXISTS `'.$db_prefix.'guildvault_contents` (`tab` varchar(100) NOT NULL, `item_num` int(3) NOT NULL, `item_name` varchar(255) NOT NULL, `item_color` varchar(255) NOT NULL, `item_tooltip` text NOT NULL, `item_icon` varchar(255) NOT NULL, `item_id` varchar(255) NOT NULL, `item_quantity` int(3) NOT NULL, KEY `tab` (`tab`), KEY `item_num` (`item_num`), KEY `item_name` (`item_name`)) ENGINE=MyISAM;';
		} else {
		  	$sql = "TRUNCATE TABLE `".$db_prefix."guildvault_contents`";
		}
		if (!$wowdb->query($sql)) {
		  	$failed_querys[] = $sql;
		}
		if ($table_guildvault_log_exists != true) {
	  		$sql = 'CREATE TABLE IF NOT EXISTS `'.$db_prefix.'guildvault_logs` (`tab` varchar(100) NOT NULL, `log_num` int(3) NOT NULL, `log_type` varchar(255) NOT NULL, `log_name` varchar(255) NOT NULL, `log_item` varchar(255) NOT NULL, `log_count` int(3) NOT NULL, `log_time` varchar(255) NOT NULL, KEY `tab` (`tab`,`log_num`,`log_type`)) ENGINE=MyISAM;';
		}
		if (!$wowdb->query($sql)) {
		  	$failed_querys[] = $sql;
		}
		if ($table_guildvault_money_exists != true) {
  			$sql = 'CREATE TABLE IF NOT EXISTS `'.$db_prefix.'guildvault_money` (`copper` tinyint(2) NOT NULL, `silver` tinyint(2) NOT NULL, `gold` int(9) NOT NULL, KEY `copper` (`copper`,`silver`,`gold`)) ENGINE=MyISAM;';
		}
		if (!$wowdb->query($sql)) {
		  	$failed_querys[] = $sql;
		}

		$output = "<br /><li>".$wordings[$roster_conf['roster_lang']]['trig_guildvault']['update']."<br/>\n";				
		# Begin GUILDVAULT INSERT / UPDATE CODE
		$realms = array_keys($uploadData['myProfile']); //Get Realms from Parsed Data;
		foreach ($realms as $realm) {
		  	$guilds = array_keys($uploadData['myProfile'][$realm]['Guild']); // Get Guilds von Realm
		  	foreach ($guilds as $guild) { // Process Data for all Guilds
				$guild_vault_data = $uploadData['myProfile'][$realm]['Guild'][$guild]['Vault']; // Write GuildVault Data in new Array

				# Get Money on GuildVault
				$gv_config['copper'] = $guild_vault_data['Money']['Copper']; 
				$gv_config['silver'] = $guild_vault_data['Money']['Silver'];
				$gv_config['gold'] = $guild_vault_data['Money']['Gold'];

				# Get all Tabs from Data that are used
				if (is_array($guild_vault_data['Tabs'])) {
				$tabs = array_keys($guild_vault_data['Tabs']);
					foreach ($tabs as $tab) { // Process each Tab-Data
					  	$gv_config['tabs'][$tab]['name'] = $guild_vault_data['Tabs'][$tab]['Name']; // Name of Tab
					  	$gv_config['tabs'][$tab]['icon'] = $guild_vault_data['Tabs'][$tab]['Icon']; // Icon of Tab
						if (is_array($guild_vault_data['Tabs'][$tab]['Contents'])) {
						  	foreach (array_keys($guild_vault_data['Tabs'][$tab]['Contents']) as $content) { // Process each content of Tab
							    $gv_contents[$tab][$content]['name'] = correct_text($guild_vault_data['Tabs'][$tab]['Contents'][$content]['Name']);
							    $gv_contents[$tab][$content]['color'] = correct_text($guild_vault_data['Tabs'][$tab]['Contents'][$content]['Color']);
							    $gv_contents[$tab][$content]['tooltip'] = correct_text($guild_vault_data['Tabs'][$tab]['Contents'][$content]['Tooltip']);
							    $gv_contents[$tab][$content]['icon'] = correct_text($guild_vault_data['Tabs'][$tab]['Contents'][$content]['Icon']);
							    $gv_contents[$tab][$content]['item'] = correct_text($guild_vault_data['Tabs'][$tab]['Contents'][$content]['Item']);
							    $gv_contents[$tab][$content]['quantity'] = correct_text($guild_vault_data['Tabs'][$tab]['Contents'][$content]['Quantity']);
						   	 	if ($gv_contents[$tab][$content]['quantity'] == '') {
							  		$gv_contents[$tab][$content]['quantity'] = 1;
								}
							}
						}
						if (is_array($guild_vault_data['Log'][$tab])) {
							foreach (array_keys($guild_vault_data['Log'][$tab]) as $log) { // Process each Log of Tab
							  	$gv_logs[$tab][$log]['type'] = $guild_vault_data['Log'][$tab][$log]['Type'];
							  	$gv_logs[$tab][$log]['name'] = $guild_vault_data['Log'][$tab][$log]['Name'];
							  	$gv_logs[$tab][$log]['item'] = $guild_vault_data['Log'][$tab][$log]['Item'];
							  	$gv_logs[$tab][$log]['count'] = $guild_vault_data['Log'][$tab][$log]['Count'];
							  	$gv_logs[$tab][$log]['time'] = $guild_vault_data['Log'][$tab][$log]['Time'];
							}
						}
						if (is_array($guild_vault_data['Log']['Money'])) {
						  	foreach (array_keys($guild_vault_data['Log']['Money']) as $log) { // Process Money Log   
							    $gv_logs['Money'][$log]['type'] = $guild_vault_data['Log']['Money'][$log]['Type'];	
							    $gv_logs['Money'][$log]['name'] = $guild_vault_data['Log']['Money'][$log]['Name'];
							    $gv_logs['Money'][$log]['time'] = $guild_vault_data['Log']['Money'][$log]['Time'];
							    $gv_logs['Money'][$log]['amount'] = $guild_vault_data['Log']['Money'][$log]['Amount'];
							}
						}
					}
				}
			}
		}
		if (is_array($gv_config)) { // Check if GuildVault Data 
		  	$sql = "SELECT * FROM `".$db_prefix."guildvault_money`";
		  	$result = $wowdb->query($sql);
			$output .= "<ul>\n";
			if (mysql_num_rows($result) <= 0) {
			 	# If no Data in DB then INSERT new
			  	$query = "INSERT INTO `".$db_prefix."guildvault_money` (`copper`, `silver`, `gold`) VALUES ('".$gv_config['copper']."', '".$gv_config['silver']."', '".$gv_config['gold']."')";
		  	}
		  	else {
		  	  	# Else Update Data
			    $query = "UPDATE `".$db_prefix."guildvault_money` SET `copper` = '".$gv_config['copper']."', `silver`= '".$gv_config['silver']."', `gold`= '".$gv_config['gold']."'";
			}
			if (!$wowdb->query($sql)) {
			  	$failed_querys[] = $sql;
			}
			$output .= "<li>".$wordings[$roster_conf['roster_lang']]['trig_guildvault']['update_money']."</li>\n";
			foreach (array_keys($gv_config['tabs']) as $tab) {
			  	$sql = "SELECT * FROM `".$db_prefix."guildvault_config` WHERE `tab` = '$tab'";
			  	$result = $wowdb->query($sql);
			  	if (mysql_num_rows($result) > 0) {
				    $sql = "UPDATE `".$db_prefix."guildvault_config` SET `name` = '".$gv_config['tabs'][$tab]['name']."', `icon` = '".$gv_config['tabs'][$tab]['icon']."' WHERE `tab` = '$tab'";
				}
				else {
				  	$sql = "INSERT INTO `".$db_prefix."guildvault_config` (`tab`, `name`, `icon`) VALUES ('$tab', '".$gv_config['tabs'][$tab]['name']."', '".$gv_config['tabs'][$tab]['icon']."')";
				}
				if (!$wowdb->query($sql)) {
				  	$failed_querys[] = $sql;
				}
			}
			$output .= "<li>".$wordings[$roster_conf['roster_lang']]['trig_guildvault']['update_config']."</li>\n";							  					
		}
		if (is_array($gv_contents)) {
		  	foreach (array_keys($gv_contents) as $tab) {
				foreach (array_keys($gv_contents[$tab]) as $item_num) {
				  	$item = $gv_contents[$tab][$item_num];
				  	$sql = "SELECT * FROM `".$db_prefix."guildvault_contents` WHERE `tab` = '$tab' AND `item_num` = '$item_num'";
				  	$result = $wowdb->query($sql);
				  	$item['tooltip'] = str_replace('\'', '\\\'', $item['tooltip']);
				  	if (mysql_num_rows($result) > 0) {
						$sql = "UPDATE `".$db_prefix."guildvault_contents` SET `item_name` = '".$item['name']."', `item_color` = '".$item['color']."', `item_tooltip` = '".$item['tooltip']."', `item_icon` = '".$item['icon']."', `item_id` = '".$item['item']."', `item_quantity` = '".$item['quantity']."' WHERE `tab` = '$tab' AND `item_num` = '$item_num'";
					}
					else {
					  	$sql = "INSERT INTO `".$db_prefix."guildvault_contents` (`tab`, `item_num`, `item_name`, `item_color`, `item_tooltip`, `item_icon`, `item_id`, `item_quantity`) VALUES ('".$tab."', '".$item_num."', '".$item['name']."', '".$item['color']."', '".$item['tooltip']."', '".$item['icon']."', '".$item['item']."', '".$item['quantity']."')";
					} 
					if (!$wowdb->query($sql)) {
					  	$output .= "<li style=\"color:#FF0000\">".$wordings[$roster_conf['trig_guildvault']]['failure']."&nbsp;".$item['name']." -> ".$gv_config['tabs'][$tab]['name']."</li>";
					  	$failure_querys[] = $sql;
					}
					else {
					  	if ($item['name'] != '') {
						  	$output .= "<li style=\"color:#00FF00\">".$item['name']." -> ".$gv_config['tabs'][$tab]['name'].$wordings[$roster_conf['roster_lang']]['trig_guildvault']['processed']."</li>";
						}
						else {
						  	$output .= "<li style=\"color:#00FF00\">".$wordings[$roster_conf['roster_lang']]['trig_guildvault']['no_item']." -> ".$gv_config['tabs'][$tab]['name'].$wordings[$roster_conf['roster_lang']]['trig_guildvault']['processed']."</li>";						  
						}
					}
				}
				$output .= "<li>".$wordings[$roster_conf['roster_lang']]['trig_guildvault']['update_content'].$gv_config['tabs'][$tab]['name']."]</li>\n";							  
				if (is_array($gv_logs)) {
					$logs = $gv_logs[$tab];
					foreach (array_keys($logs) as $log_num) {
					  	$sql = "SELECT * FROM `".$db_prefix."guildvault_logs` WHERE `tab` = '$tab' AND `log_num` = '$log_num'";
					  	$result = $wowdb->query($sql);
					  	if (mysql_num_rows($result) > 0) {
						    $sql = "UPDATE `".$db_prefix."guildvault_logs` SET `log_type` = '".$logs[$log_num]['type']."', `log_name` = '".$logs[$log_num]['name']."', `log_item` = '".$logs[$log_num]['item']."', `log_count` = '".$logs[$log_num]['count']."', `log_time` = '".$logs[$log_num]['time']."' WHERE `tab` = '$tab' AND `log_num` = '$log_num'";
						}
						else {
						  	$sql = "INSERT INTO `".$db_prefix."guildvault_logs` (`tab`, `log_num`, `log_type`, `log_name`, `log_item`, `log_count`, `log_time`) VALUES ('$tab', '$log_num', '".$logs[$log_num]['type']."', '".$logs[$log_num]['name']."', '".$logs[$log_num]['item']."', '".$logs[$log_num]['count']."', '".$logs[$log_num]['time']."')";
						}
						if (!$wowdb->query($sql)) {
		  					$failed_querys[] = $sql;
						}
					}
					$output .= "<li>".$wordings[$roster_conf['roster_lang']]['trig_guildvault']['update_log'].$gv_config['tabs'][$tab]['name']."]</li>\n";							  
				}
			}
			$logs = $gv_logs['Money'];
			$tab = 'Money';
			foreach (array_keys($logs) as $log_num) {
			  	$sql = "SELECT * FROM `".$db_prefix."guildvault_logs` WHERE `tab` = '$tab' AND `log_num` = '$log_num'";
			  	$result = $wowdb->query($sql);
			  	if (mysql_num_rows($result) > 0) {
				    $sql = "UPDATE `".$db_prefix."guildvault_logs` SET `log_type` = '".$logs[$log_num]['type']."', `log_name` = '".$logs[$log_num]['name']."', `log_count` = '".$logs[$log_num]['amount']."', `log_time` = '".$logs[$log_num]['time']."' WHERE `tab` = '$tab' AND `log_num` = '$log_num'";
				}
				else {
				  	$sql = "INSERT INTO `".$db_prefix."guildvault_logs` (`tab`, `log_num`, `log_type`, `log_name`, `log_count`, `log_time`) VALUES ('$tab', '$log_num', '".$logs[$log_num]['type']."', '".$logs[$log_num]['name']."', '".$logs[$log_num]['amount']."', '".$logs[$log_num]['time']."')";
				}
				if (!$wowdb->query($sql)) {
				  	$failed_querys[] = $sql;
				}
			}						
			$output .= "<li>".$wordings[$roster_conf['roster_lang']]['trig_guildvault']['update_money_log']."</li>\n";							  
		}
		# END GUILDVAULT INSERT / UPDATE CODE
		$output .= "</ul></li>\n";
		$output .= "\n";
		echo $output;
		if( $addon_conf['guildvault']['debug']) {		
			if (is_array($failure_querys)) {
		  		foreach ($failure_querys as $failure_query) {
				    $result = $wowdb->query($failure_query);
				    echo $failure_query." -> ".$wowdb->error()."<br />";
				}
			}
		}
	}
}
